#!/usr/bin/env python
# -*- coding: UTF8 -*-

# Python module iwScanner.py
# Autogenerated from iwScanner.glade
# Generated on Sat Sep  6 16:23:32 2008

# Warning: Do not modify any context comment such as #--
# They are required to keep user's code

import os
import re
import time
import struct

import gtk
import gobject
from SimpleGladeApp import SimpleGladeApp
from SimpleGladeApp import bindtextdomain
from threading import Thread
import pango
from datetime import datetime

app_name = "iwScanner"
app_version = "0.2.4"
app_web = "http://kuthulu.com/iwscanner"

glade_dir = ""
locale_dir = ""

bindtextdomain(app_name, locale_dir)

gtk.gdk.threads_init()

MAX_SAMPLES=300

class Wmain(SimpleGladeApp):

    def __init__(self, path="iwscanner.glade",
                 root="wMain",
                 domain=app_name, **kwargs):        
        path = os.path.join(glade_dir, path)
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)
        self.initMainPane()
        self.initLeftPane()
        self.initDrawPane()        
        self.sbInfo.push(self.sbInfo.get_context_id("a"), "Not Scanning")

        self.get_widget("wMain").maximize()

    #-- Wmain.new {
    def new(self):        
        self.running = 0
        self.wMain = self.get_widget("wMain")
        self.btnStart = self.get_widget("btnStart")
        self.treeMain = self.get_widget("treeMain")
        self.treeLeft = self.get_widget("treeLeft")
        self.drawGraph = self.get_widget("drawGraph")
        self.sbInfo = self.get_widget("sbInfo")
        self.cmbDevice = self.get_widget("cmbDevice")
        self.hSpeed = self.get_widget("hSpeed")
        self.lblSpeed = self.get_widget("lblSpeed")
        self.tips = gtk.Tooltips()
        self.results={}
        self.data={}
        self.macToGraph=""
        self.speeds=[1, 0.5, 0.2, 0]
        self.speedsDesc=["slow", "normal", "fast", "fastest"]
        self.lastPath = os.path.expanduser("~")
    #-- Wmain.new }

    #-- Wmain custom methods {
    #   Write your own methods here
    #-- Wmain custom methods }

    #-- Wmain.on_wMain_destroy {
    def on_wMain_destroy(self, widget, *args):
        self.running = 0
        try:
            self.scanner.stop()
        except:
            pass
        gtk.main_quit()
    #-- Wmain.on_wMain_destroy }

    #-- Wmain.on_open1_activate {
    def on_open1_activate(self, widget, *args):
        self.showOpen()
    #-- Wmain.on_open1_activate }

    #-- Wmain.on_ns1_netstumbler1_activate {
    def on_ns1_netstumbler1_activate(self, widget, *args):
        self.showSave("ns1")
    #-- Wmain.on_ns1_netstumbler1_activate }

    #-- Wmain.on_ndd_netdetect1_activate {
    def on_ndd_netdetect1_activate(self, widget, *args):
        self.showSave("ndd")
    #-- Wmain.on_ndd_netdetect1_activate }

    #-- Wmain.on_quit1_activate {
    def on_quit1_activate(self, widget, *args):
        self.on_wMain_destroy(self, widget, args)
    #-- Wmain.on_quit1_activate }

    #-- Wmain.on_about1_activate {
    def on_about1_activate(self, widget, *args):
        if not hasattr(self, 'about') or self.about==None or self.about.get_widget("dlgAbout")==None:        
            self.about = Dlgabout()
        
        self.about.get_widget("dlgAbout").show()
    #-- Wmain.on_about1_activate }

    #-- Wmain.on_btnStart_clicked {
    def on_btnStart_clicked(self, widget, *args):
        if (not self.running):
            self.running=1
            self.scanner = ScannerThread(self.resultsHandler)
            self.scanner.setDevice(self.cmbDevice.get_active_text())
            self.scanner.start()
            self.sbInfo.push(self.sbInfo.get_context_id("a"), "Scanning %s...\t" % (self.cmbDevice.get_active_text()))
    #-- Wmain.on_btnStart_clicked }

    #-- Wmain.on_btnStop_clicked {
    def on_btnStop_clicked(self, widget, *args):
        if (self.running):
            self.running=0
            self.scanner.stop()
            self.sbInfo.push(self.sbInfo.get_context_id("a"), "Not Scanning")
    #-- Wmain.on_btnStop_clicked }

    #-- Wmain.on_btnClear_clicked {
    def on_btnClear_clicked(self, widget, *args):
        self.model.clear()
    #-- Wmain.on_btnClear_clicked }

    #-- Wmain.on_hSpeed_value_changed {
    def on_hSpeed_value_changed(self, widget, *args):
        if hasattr(self, "scanner"):
            self.scanner.sleepTime = self.speeds[int(self.hSpeed.get_value()-1)]        
    #-- Wmain.on_hSpeed_value_changed }

    #-- Wmain.on_hSpeed_change_value {
    def on_hSpeed_change_value(self, widget, *args):
        self.lblSpeed.set_text(self.speedsDesc[int(self.hSpeed.get_value()-1)])
    #-- Wmain.on_hSpeed_change_value }

    #-- Wmain.on_drawGraph_expose_event {
    def on_drawGraph_expose_event(self, widget, *args):        
        self.paintGraph(self.drawGraph.allocation.width, self.drawGraph.allocation.height)
    #-- Wmain.on_drawGraph_expose_event }


    #-- Wmain.on_drawGraph_configure_event {
    def on_drawGraph_configure_event(self, widget, *args):
        x, y, width, height = widget.get_allocation()
        self.backbuffer = gtk.gdk.Pixmap(widget.window, width, height)
        self.backgc = self.backbuffer.new_gc()
        self.backgc.set_colormap(self.colormap)        
    #-- Wmain.on_drawGraph_configure_event }

    def on_treeMain_selection_changed_event(self, widget, *args):   
        mac = self.model.get_value(widget.get_selected()[1],0)
        self.macToGraph = mac        
        self.drawGraph.queue_draw()

    def on_treeLeft_selection_changed_event(self, widget, *args):   
        mac = self.treeModel.get_value(widget.get_selected()[1],0)
        if len(mac)==17:
            self.macToGraph = mac        
            self.drawGraph.queue_draw()

    def showSave(self, extension):        
        dlg = gtk.FileChooserDialog(title="Save as", parent=self.wMain, action=gtk.FILE_CHOOSER_ACTION_SAVE)
        dlg.add_button(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)
        dlg.add_button(gtk.STOCK_SAVE, gtk.RESPONSE_OK)        
        dlg.set_do_overwrite_confirmation(True)
        dlg.set_current_name( os.path.basename("iwscanner-%s.%s" % (time.strftime("%Y%m%d%H%M%S"), extension) ))
        dlg.set_current_folder( self.lastPath )
        
        if dlg.run() == gtk.RESPONSE_OK:
            filename = dlg.get_filename()
            self.lastPath = os.path.dirname(filename)
            if not filename.endswith(extension):
                filename += "." + extension

            try:                
                if (extension == "ns1"):
                    self.saveNS1(filename)
                elif (extension == "ndd"):                   
                    self.saveNDD(filename)                

            except:
                
                dlg.destroy()
                self.msgbox("Error, can't open %s for writing" % (filename))
                return
            
        dlg.destroy()

    def showOpen(self):
        dlg = gtk.FileChooserDialog(title="Open", parent=self.wMain, action=gtk.FILE_CHOOSER_ACTION_OPEN)
        dlg.add_button(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)
        dlg.add_button(gtk.STOCK_OPEN, gtk.RESPONSE_OK)        
        dlg.set_do_overwrite_confirmation(True)
        dlg.set_current_folder( self.lastPath )

        if dlg.run() == gtk.RESPONSE_OK:
            filename = dlg.get_filename()
            self.lastPath = os.path.dirname(filename)
            if filename.endswith(".ndd"):
                self.openNDD(filename)
            else:
                self.openNS1(filename)
        
        dlg.destroy()
        

    def msgbox(self, text):
        msgBox = gtk.MessageDialog(parent = self.wMain, buttons = gtk.BUTTONS_OK, message_format = text)
        msgBox.run()
        msgBox.destroy()    

    def saveNDD(self, filename):
        f = open(filename, "w")
        f.write("NDED2\n//Created by iwScanner http://kuthulu.com/iwscanner\n")
        for row in self.model:            
            mac = re.sub(":", "", row[0])
            ssid = row[1]
            mode = "BSS" if row[2]=="Master" else "IBSS"
            channel = row[3]
            encrypt = row[4]
            speed = row[7]
            first = row[8]
            last = row[9]
            line = "\n<nt %s;%s;%s;%i;%s;%s;%i;%i;>" % (mac, ssid, encrypt, channel, speed, mode, first, last)
            f.write(line)
        f.close()

    def openNDD(self, filename):
        try:
            f = open(filename, "r")
        except:
            self.msgbox("Can't open %s for reading" % filename)
            return
        s = f.readline()
        
        if (s.strip() != "NDED2"):
            self.msgbox("Invalid file format")
            return
        
        self.model.clear()
        nets={}
        for line in f.xreadlines():            
            if line[0:4] == "<nt ":
                data = line[4:].split(";")
                mac = data[0][0:2] + ":" + data[0][2:4] + ":" + data[0][4:6] + ":" + data[0][6:8] + ":" + data[0][8:10] + ":" + data[0][10:12]
                net = Network()
                net.bssid = mac
                net.ssid = data[1]
                net.encrypt = data[2]
                net.channel = data[3]
                net.speed = data[4]
                net.mode = "Master" if data[5]=="BSS" else "Ad-Hoc"
                net.signal = -100
                nets[net.bssid] = net
        
        self.resultsHandler(nets)
        
        f.close()

    def saveNS1(self, filename):
        f = open(filename, "wb")
        
        #write header, version and number of APs
        data = struct.pack("<4sii", "NetS", 12, self.model.iter_n_children(None))
        f.write(data)
        
        for row in self.model:            
            mac = re.sub(":", "", row[0])
            ssid = row[1]
            mode = "BSS" if row[2]=="Master" else "IBSS"
            channel = row[3]
            encrypt = row[4]
            speed = row[7]
            first = row[8]
            last = row[9]
            maxsignal = row[10]
            minnoise = row[11]
            flags = 0x1 if mode == "BSS" else 0x2
            if encrypt != "OFF":
                flags |= 0x10

            funix = int(first)*pow(10,8)
            lunix = int(last)*pow(10,8)

            #write ssid length, ssid, mac, max signal, min noise, max signal to noise, flags, beacon interval, 
            #      first seen, last seen, latitude, longitude, #s ap data, AP data, name length, name,
            #      channel activity, last channel, ip, min signal, max noise, data rate, ip subnet, subnet mask, 
            #      misc flags, bytes follow, info elements
            data = struct.pack("<B%ss6B14iB11i" % (len(ssid)), \
                            len(ssid),  #ssid length
                            ssid,       #ssid
                            int(mac[0:2],16), int(mac[2:4],16), int(mac[4:6],16),  #mac
                            int(mac[6:8],16), int(mac[8:10],16), int(mac[10:12],16),
                            maxsignal,          #max signal
                            minnoise,          #min noise
                            0,          #max signal to noise
                            flags,      #capability flags
                            0,          #beacon interval
                            funix & 0x00000000ffffffff, funix >> 32,  #first seen
                            lunix & 0x00000000ffffffff, lunix >> 32,  #last seen
                            0, 0,       #latitude
                            0, 0,       #longitude
                            0,          #number of aps data, so no AP data to write 
                            0,          #name length, so no name to write
                            1<<int(channel), 0, #channel activity
                            int(channel),    #channel
                            0,          #ip
                            0,          #min signal
                            0,          #max noise
                            int(speed)*10,          #highest data rate
                            0,          #ip subnet 
                            0,          #ip subnet mask 
                            0,          #misc flags
                            0,          #extra bytes
                              )
            f.write(data)

        f.close()

    def openNS1(self, filename):
        try:
            f = open(filename, "rb")
        except:
            self.msgbox("Can't open %s for reading" % filename)
            return
        
        #read header, version and number of APs
        try:
            data = struct.unpack("<4sii", f.read(12))
        except:
            self.msgbox("Invalid file format")
            f.close()
            return
            
        if data[0] != "NetS" and data[1]!=12:
            self.msgbox("Invalid file format")
            f.close()
            return
        
        n = int(data[2])
        
        self.model.clear()
        nets={}
        
        try:
            
            for i in range(0,n):            
                data = struct.unpack("<B", f.read(1))
                ssidLength = int(data[0])
                
                data = struct.unpack("<%ss6B14i" % (ssidLength), f.read( ssidLength + 6 + 14*4 ))
                apsData = int(data[20])
                for j in range(0,apsData):
                    apData = struct.unpack("<5i", f.read(20))
                    if (apData[4]==1):
                        gpsData = apData = struct.unpack("<15i", f.read(60))
                
                net = Network()
                net.ssid = data[0]
                net.bssid = "%02X:%02X:%02X:%02X:%02X:%02X" % (data[1], data[2], data[3], data[4], data[5], data[6])
                net.signal = data[7] if data[7] != 0 else -100
                flags = data[10]
                net.mode = "Master" if flags & 0x1 == 0x1 else "Ad-Hoc"
                net.encrypt = "WEP" if flags & 0x10 == 0x10 else "OFF"
                
                data = struct.unpack("<B", f.read(1))
                nameLength = int(data[0])            
                data = struct.unpack("<%ss11i" % (nameLength), f.read(nameLength + 11*4))           
                bytesFollow = data[11]
                f.read(bytesFollow)
                
                net.channel = data[3]
                net.speed = data[7] / 10
                
                nets[net.bssid] = net
                
            self.resultsHandler(nets)
            
        except:
            self.msgbox("Invalid file format")
            
        f.close()


    def initMainPane(self):
        self.model = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, \
                              gobject.TYPE_INT, gobject.TYPE_STRING, gobject.TYPE_INT, \
                              gobject.TYPE_INT, gobject.TYPE_INT, gobject.TYPE_INT, gobject.TYPE_INT, \
                              gobject.TYPE_INT, gobject.TYPE_INT)
        self.treeMain.set_model(self.model)
        column = gtk.TreeViewColumn("MAC", gtk.CellRendererText(), text=0)
        column.set_sort_column_id(0) 
        self.treeMain.append_column( column )
        column = gtk.TreeViewColumn("SSID", gtk.CellRendererText(), text=1)
        column.set_sort_column_id(1) 
        self.treeMain.append_column( column )
        column = gtk.TreeViewColumn("Mode", gtk.CellRendererText(), text=2)
        column.set_sort_column_id(2) 
        self.treeMain.append_column( column )
        column = gtk.TreeViewColumn("Channel", gtk.CellRendererText(), text=3)
        column.set_sort_column_id(3) 
        self.treeMain.append_column( column )
        column = gtk.TreeViewColumn("Encrypt", gtk.CellRendererText(), text=4)
        column.set_sort_column_id(4) 
        self.treeMain.append_column( column )
        column = gtk.TreeViewColumn("Signal", gtk.CellRendererText(), text=5)
        column.set_sort_column_id(5) 
        self.treeMain.append_column( column )
        column = gtk.TreeViewColumn("Quality", gtk.CellRendererText(), text=6)
        column.set_sort_column_id(6) 
        self.treeMain.append_column( column )
        column = gtk.TreeViewColumn("Speed", gtk.CellRendererText(), text=7)
        column.set_sort_column_id(7) 
        self.treeMain.append_column( column )
        column = gtk.TreeViewColumn("Max Signal", gtk.CellRendererText(), text=10)
        column.set_sort_column_id(10) 
        self.treeMain.append_column( column )
        self.treeMain.set_reorderable(True)
        self.treeMain.get_selection().connect("changed", self.on_treeMain_selection_changed_event)
        
        devs = os.popen("iwconfig 2>/dev/null| grep essid -i|awk '{print $1}'").read()
        s = re.split("\n",devs.strip())
        self.cmbDevice.get_model().clear()
        for d in s:
            self.cmbDevice.get_model().append([d])    
        if len(s)>0:
            self.cmbDevice.get_child().set_text(s[0])        
        
        self.tips.set_tip(self.hSpeed, "Scanning speed")
        self.tips.set_tip(self.cmbDevice, "Device to use for scanning")
        self.tips.set_tip(self.btnStart, "Start scanning")
        self.tips.set_tip(self.btnStop, "Stop scanning")
        

    def initLeftPane(self):
        self.treeModel = gtk.TreeStore(gobject.TYPE_STRING)
        self.treeLeft.set_model(self.treeModel)
        for chan in range(1,14):
            i = self.treeModel.append(None, [str(chan)])        
            
        column = gtk.TreeViewColumn("Channels", gtk.CellRendererText(), text=0)
        self.treeLeft.append_column( column )
        self.treeLeft.get_selection().connect("changed", self.on_treeLeft_selection_changed_event)

    def initDrawPane(self):        
        self.drawable = self.drawGraph.window
        self.gc = self.drawable.new_gc()        
        self.colormap = self.gc.get_colormap()
        self.colors = {}
        self.colors['green'] = self.colormap.alloc_color(0, 50000, 0)
        self.colors['black'] = self.colormap.alloc_color('black')
        self.colors['white'] = self.colormap.alloc_color('white')
        self.colors['red'] = self.colormap.alloc_color('red')
        self.gc.set_background(self.colors['black'])


    def paintGraph(self, width, height):
        t1 = datetime.now()

        BAR_WIDTH = (width-30)/MAX_SAMPLES
        if BAR_WIDTH<1:
            BAR_WIDTH=1

        self.backgc.set_foreground(self.colors['black'])        
        self.backbuffer.draw_rectangle(self.backgc, True, 0, 0, width, height)

        self.paintAxis(width, height)
    
        height -= 10

        try:
            t = 0
            for x in self.data[self.macToGraph]:                
                if x>-100:
                    self.backgc.foreground = self.colors['green']
                else:
                    self.backgc.foreground = self.colors['red']
                self.backbuffer.draw_rectangle(self.backgc, True, 31 + t * BAR_WIDTH, \
                                             height-(101+x)*height/101, BAR_WIDTH, (101+x)*height/101)
                t=t+1
        except:
            pass

        height += 10        

        self.drawable.draw_drawable(self.gc,self.backbuffer,0,0,0,0,width,height)
        
        t2 = datetime.now()        

    def paintAxis(self, width, height):
        self.backgc.foreground = self.colors['white']
        self.backbuffer.draw_line(self.backgc, 30, 0, 30, height)
        self.backbuffer.draw_line(self.backgc, 25, height-10, width, height-10)
        height -= 10
        for h in range(0,11):
            self.backbuffer.draw_line(self.backgc, 25, height-(101-h*10)*height/101, 29, height-(101-h*10)*height/101)
            layout = self.drawGraph.create_pango_layout("-%d" % (h*10) )
            layout.get_context().get_font_description().set_size(8)
            self.backbuffer.draw_layout(self.backgc,1,-10+height-(101-h*10)*height/101,layout)

    def resultsHandler(self, results):        
        self.results = results        

        self.sbInfo.push(self.sbInfo.get_context_id("a"), "Scanning %s...\t%d APs active" % (self.cmbDevice.get_active_text(), len(results)))

        for row in self.model:            
            mac = row[0]
            if (self.results.has_key(mac)):
                net = self.results[mac]
                row[1] = net.ssid
                row[2] = net.mode
                row[3] = int(net.channel)
                row[4] = net.encrypt
                row[5] = int(net.signal)
                row[6] = int(net.quality)
                row[7] = int(float(net.speed))
                #row[8] first seen
                row[9] = int(time.time()) #last seen
                if (int(net.signal)>row[10]): #max signal
                    row[10] = int(net.signal) 
                #row[11] #min noise
                net.used = True
                self.data[mac].append(int(net.signal))
            else:                
                row[5] = -100
                row[6] = 0
                self.data[mac].append(-100)
            if len(self.data[mac])>MAX_SAMPLES:
                del self.data[mac][0]
                
        for mac in self.results:
            if not self.results[mac].used:
                self.model.append([self.results[mac].bssid, self.results[mac].ssid, self.results[mac].mode, \
                                  int(self.results[mac].channel), self.results[mac].encrypt, int(self.results[mac].signal), \
                                  int(self.results[mac].quality), int(self.results[mac].speed), \
                                  int(time.time()), int(time.time()), int(self.results[mac].signal), -100 ])
                for row in self.treeModel:
                    if row[0]==self.results[mac].channel:
                        self.treeModel.append(row.iter, [mac])
                self.data[mac] = []
                self.data[mac].append(int(self.results[mac].signal))
            self.results[mac].used = False
        
        self.drawGraph.queue_draw()


class Network:
    "Represent a network"
    def __init__(self, ssid, bssid, mode, channel, encrypt, signal, quality, speed):
        self.ssid = ssid
        self.bssid = bssid
        self.mode = mode
        self.channel = channel
        self.encrypt = encrypt
        self.signal = signal
        self.quality = quality
        self.speed = speed
        self.used = False

    def __init__(self):
        self.ssid = ""
        self.bssid = "0:0:0:0:0:0"
        self.mode = ""
        self.channel = "0"
        self.encrypt = "OFF"
        self.signal = "0"
        self.quality = "0"
        self.speed = "0"
        self.used = False

    def __str__(self):
        return "mac[%s], essid[%s], mode[%s], chan[%s], enc[%s], signal[%s], qual[%s], speed[%s]" % \
              (self.bssid, self.ssid, self.mode, self.channel, self.encrypt, self.signal, self.quality, self.speed)

    def read(self, network):
        self.ssid = network.ssid
        self.bssid = network.bssid
        self.mode = network.mode
        self.channel = network.channel
        self.encrypt = network.encrypt
        self.signal = network.signal
        self.quality = network.quality
        self.speed = network.speed
        



class ScannerThread(Thread):

    def __init__ (self, handler):
        Thread.__init__(self)
        self.device = ""
        self.handler = handler
        self.scanner = Scanner("eth1")
        self.sleepTime = 1.0
        self.isRunning = True
        
    def setDevice(self, device):
        self.scanner.setDevice(device)

    def stop(self):
        self.isRunning = False
        
    def run(self):            
        while self.isRunning:
            if not self.isRunning: break
            t1 = datetime.now()

            results = self.scanner.scan()

            t2 = datetime.now()
            print "scan time: %d" % ((t2-t1).microseconds/1000)
            t1 = datetime.now()

            self.handler(results)

            t2 = datetime.now()            

            if not self.isRunning: break
            time.sleep(self.sleepTime)

class Scanner:
    "Class to scan and parse the result"
    def __init__(self, device):
        self.networks = {}
        self.device = device
        self.scanCommand = "iwlist " + device + " scan"

    def setDevice(self, device):
        self.device = device
        self.scanCommand = "iwlist " + device + " scan"            

    def scan(self):
        nets={}
        res = os.popen(self.scanCommand).read()
        res = re.sub("\n *", "\n", res)
        s = re.split("\n *Cell \d\d - ",res)
        del s[0]
        for x in s:
            net = Network()
            for y in x.split("\n"):                
                pair = re.sub("^([\w ]*): *", "\\1\\\\", y).split("\\")                
                if (pair[0]=="ESSID"):
                    net.ssid = pair[1].replace("\"", "")
                elif (pair[0]=="Address"):
                    net.bssid = pair[1]
                elif (pair[0]=="Mode"):
                    net.mode = pair[1]
                elif (pair[0]=="Channel"):
                    net.channel = pair[1]
                elif (pair[0]=="Frequency"):
                    net.channel = pair[1].replace(")", "").split()[3]
                elif (pair[0]=="Encryption key"):
                    if (pair[1]=="on"):
                        net.encrypt = "WEP"
                    else:
                        net.encrypt = "OFF"
                elif (pair[0]=="IE"):
                    if (pair[1].find("WPA2")>=0):
                        net.encrypt = "WPA2"
                    elif (pair[1].find("WPA")>=0):
                        net.encrypt = "WPA"                        
                elif (pair[0]=="Bit Rates"):
                    tmp = re.split("[ ;]",pair[1])                    
                    net.speed = tmp[len(tmp)-2]
                elif (pair[0]=="Quality"):
                    tmp = re.split("[=/ :]", pair[1])
                    net.quality = tmp[0]
                    net.signal = tmp[5] if int(tmp[5])<0 else int(tmp[5])-100
                else:
                    tmp = re.split("[ ;]",pair[0])
                    if (len(tmp)>1 and tmp[1]=="Mb/s"):
                        net.speed = tmp[len(tmp)-2]                
                    tmp = re.split("[=/ :]", pair[0])
                    if (tmp[0] == "Quality"):
                        net.quality = tmp[1]
                        net.signal = tmp[6] if int(tmp[6])<0 else int(tmp[6])-100

            nets[net.bssid]=net        
        return nets
        
class Dlgabout(SimpleGladeApp):

    def __init__(self, path="iwscanner.glade",
                 root="dlgAbout",
                 domain=app_name, **kwargs):
        path = os.path.join(glade_dir, path)
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)

    #-- Dlgabout.new {
    def new(self):
        self.dlgAbout.set_name(app_name)
        self.dlgAbout.set_version(app_version)
        self.dlgAbout.set_website(app_web)    
    #-- Dlgabout.new }

    #-- Dlgabout custom methods {
    #   Write your own methods here
    #-- Dlgabout custom methods }

    #-- Dlgabout.on_dlgAbout_response {
    def on_dlgAbout_response(self, widget, *args):       
        widget.hide()
    #-- Dlgabout.on_dlgAbout_response }


#-- main {

def main():
    w_main = Wmain()
    
    w_main.run()

if __name__ == "__main__":
    main()

#-- main }
